/*
   ----------------------------------------------------------------------------
	RowsetToCSVFile.prg
   A sample dBL program from 
   The dBASE Book Plus by Kenneth J. Mayer. 
   Program copyright 2015. 
   Permission is granted for use as a learning tool for dBASE Plus.
   Sample from: Chapter 3
	
	From Hans-Peter's documentation, RowsetToCSVFile
	
   A program to show the basic use of the following Objects:
	   ADOStream
		
	This program contains the function RowsetToCSVFile, requires that you
	pass the object reference to an ADORowset and the name of an output
	file. This will loop through the rows and fields in a rowset and stream
	out the information to a .CSV file.
	----------------------------------------------------------------------------
*/

function RowsetToCSVFile( oRow, cFile )

   oStream = new ADOStream()
	oStream.type := 0 // Text
	oStream.lineSeparator := 0 // CRLF
	oStream.open() // open empty stream
	
	// Output the fieldnames:
	nCount = oRow.fields.size
	for n = 1 to ncount
	    oStream.write( oRow.fields[n].name )
		 if (n < nCount )
		    oStream.write( "," )
		 else
		    oStream.write( "", true ) // write line separator
		 endif
	endfor // loop through fieldnames
	
	// loop through the data:
	oRow.top()
	do
	   for n = 1 to ncount
		    oStream.write( oRow.fields[n].value )
			 if (n < nCount)
			    oStream.write( "," )
			 else
			    oStream.write( "", true ) // write line separator
			 endif
		endfor
   while oRow.next()
	
   // write the data:
   oStream.saveToFile( cFile )

return
// End of function: RowsetToCSVFile